module.exports = {
  parser: '@typescript-eslint/parser',
  plugins: ['@typescript-eslint', 'react'],
  extends: [
    'eslint:recommended',
    'plugin:@typescript-eslint/eslint-recommended',
    'plugin:@typescript-eslint/recommended',
    'plugin:prettier/recommended',
    'airbnb',
  ],
  globals: {

  },
  env: {
    browser: true,
    node: true,
  },
  settings: {
    'import/resolver': {
      node: {
        extensions: ['.js', '.jsx', '.ts', '.tsx', '.d.ts'],
      },
    },
  },
  rules: {
    'arrow-body-style': 'off',
    'global-require': 'off',
    camelcase: 'off',
    '@typescript-eslint/camelcase': 'off',
    '@typescript-eslint/ban-ts-comment': 'off',
    'import/no-extraneous-dependencies': 'off',
    'react/prop-types': 'off',
    'jest/no-disabled-tests': 'off',
    'jest/no-focused-tests': 'off',
    'jest/no-identical-title': 'off',
    'jest/prefer-to-have-length': 'off',
    'jest/valid-expect': 'off',
    'object-curly-newline': 'off',
    'react/jsx-filename-extension': 'off',
    'react/jsx-no-undef': 'off',
    'react/jsx-indent': 'off',
    'react/style-prop-object': 'off',
    'react/no-access-state-in-setstate': 'off',
    'no-shadow': 'off',
    'max-classes-per-file': 'off',
    'max-len': [0, 100, 4],
    calemcase: 'off',
    'class-methods-use-this': 'off',
    'react/destructuring-assignment': 'off',
    'consistent-return': 'off',
    'array-callback-return': 'off',
    'import/named': 'off',
    'import/prefer-default-export': 1,
    'one-var': 'off',
    'no-underscore-dangle': 'off',
    'no-plusplus': 'off',
    'react/jsx-tag-spacing': 'off',
    'react/jsx-wrap-multilines': 'off',
    'no-console': 'off',
    'no-octal-escape': 'off',
    '@typescript-eslint/no-var-requires': 'off',
    'no-empty': 1,
    'no-unused-expressions': 1,
    'no-multi-assign': 'off',
    'import/first': 1,
    'prefer-promise-reject-errors': 1,
    'import/extensions': 'off',
    'prefer-const': 1,
    'no-restricted-properties': [
      2,
      {
        object: 'Proxy',
      },
    ],
    indent: 'off',
    'space-before-function-paren': 'off',
    'import/no-unresolved': 'off',
    'no-unused-vars': 'off',
    'lines-between-class-members': 'off',
    'no-bitwise': 'off',
    'no-restricted-syntax': 1,
    'no-nested-ternary': 1,
    'no-control-regex': 'off',
    'react/no-unknown-property': 'off',
    'react/jsx-one-expression-per-line': 'off',
    'react/button-has-type': 'off',
    'spaced-comment': 'off',
    'react/sort-comp': 'off',
    'no-useless-constructor': 'off',
    'react/jsx-indent-props': 'off',
    '@typescript-eslint/no-explicit-any': 'off',
    'no-param-reassign': 'off',
    '@typescript-eslint/array-type': 'off',
    '@typescript-eslint/explicit-member-accessibility': 'off',
    'react/no-array-index-key': 'off',
    '@typescript-eslint/no-non-null-assertion': 'off',
    'no-cond-assign': 'off',
    'react/static-property-placement': 'off',
    'react/jsx-props-no-spreading': 'off',
    'jsx-a11y/alt-text': 'off',
    '@typescript-eslint/ban-ts-ignore': 'off',
    '@typescript-eslint/no-empty-function': 'off',
    'no-empty-function': 'off',
    'react/state-in-constructor': 'off',
    'no-return-await': 'off',
    'jsx-a11y/click-events-have-key-events': 'off',
    'jsx-a11y/no-static-element-interactions': 'off',
    'react/prefer-stateless-function': 'off',
    'prefer-object-spread': 'off',
    'react/jsx-uses-react': 'off',
    'react/react-in-jsx-scope': 'off',
  },
};
